public class CounterIncrementer {

	public static void main(String[] args) throws Exception {
		Counter counter = new Counter();
		Incrementer incrementer1 = new Incrementer(counter, 10000);
		Incrementer incrementer2 = new Incrementer(counter, 10000);
		incrementer1.start();
		incrementer2.start();
		incrementer1.join();
		incrementer2.join();
		System.out.println(counter.getValue());
	}

	static class Counter {
		private int value = 0;

		public int getValue() {
			return value;
		}

		public synchronized void increment() {
			value = value + 1;
		}
	}

	static class Incrementer extends Thread {

		private final Counter counter;
		private final int max;

		public Incrementer(Counter counter, int max) {
			this.counter = counter;
			this.max = max;
		}

		public void run() {
			for (int i = 0; i < max; i++) {
				counter.increment();
			}
		}
	}
}
