public class InfiniteCounterThread extends Thread {

	@Override
	public void run() {
		int i = 1;
		while (true) {
			if (Thread.interrupted()) {
				System.out.println(getName() + " interrupted by flag");
				break;
			}
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				System.out.println(getName() + " interrupted by exception");
				break;
			}
			System.out.println(getName() + ": " + i++);
		}
		System.out.println(getName() + " terminating");
	}

	public static void main(String[] args) throws Exception {
		InfiniteCounterThread thread = new InfiniteCounterThread();
		thread.start();
		System.out.println("Thread started");
		Thread.sleep(5000);
		thread.interrupt();
		System.out.println("Thread interrupted");
		thread.join();
		System.out.println("Thread terminated");
	}
}
