public class SummationThread extends Thread {

	private final int min;
	private final int max;
	private long sum = 0;

	public SummationThread(int min, int max) {
		this.min = min;
		this.max = max;
	}

	public long getSum() {
		return sum;
	}

	@Override
	public void run() {
		for (int n = min + 1; n <= max; n++) {
			sum += n;
		}
	}

	public static void main(String[] args) throws Exception {
		SummationThread thread = new SummationThread(0, 100000);
		System.out.println("Thread created");
		thread.start();
		System.out.println("Thread started");
		thread.join();
		System.out.println("Thread terminated");
		System.out.println(thread.getSum());
	}
}
